// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.ApiManagement.Models;

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    /// <summary>
    /// Parameters supplied to the Upload SSL certificate for an Api Management
    /// service operation.
    /// </summary>
    public partial class ApiServiceUploadCertificateParameters
    {
        private string _certificatePassword;
        
        /// <summary>
        /// Required. Gets or sets certificate password.
        /// </summary>
        public string CertificatePassword
        {
            get { return this._certificatePassword; }
            set { this._certificatePassword = value; }
        }
        
        private string _encodedCertificate;
        
        /// <summary>
        /// Required. Gets or sets encoded certificate.
        /// </summary>
        public string EncodedCertificate
        {
            get { return this._encodedCertificate; }
            set { this._encodedCertificate = value; }
        }
        
        private HostnameType _type;
        
        /// <summary>
        /// Required. Gets or sets hostname type.
        /// </summary>
        public HostnameType Type
        {
            get { return this._type; }
            set { this._type = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// ApiServiceUploadCertificateParameters class.
        /// </summary>
        public ApiServiceUploadCertificateParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// ApiServiceUploadCertificateParameters class with required
        /// arguments.
        /// </summary>
        public ApiServiceUploadCertificateParameters(HostnameType type, string encodedCertificate, string certificatePassword)
            : this()
        {
            if (encodedCertificate == null)
            {
                throw new ArgumentNullException("encodedCertificate");
            }
            if (certificatePassword == null)
            {
                throw new ArgumentNullException("certificatePassword");
            }
            this.Type = type;
            this.EncodedCertificate = encodedCertificate;
            this.CertificatePassword = certificatePassword;
        }
    }
}
