// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Automation.Models
{
    /// <summary>
    /// The parameters supplied to the list job operation.
    /// </summary>
    public partial class DscNodeReportListParameters
    {
        private string _endTime;
        
        /// <summary>
        /// Optional. For the end time filter the value should be a datetime
        /// string in UTC format as defined in ISO 8601. For example,
        /// 2014-09-25T17:49:17.2252204Z
        /// </summary>
        public string EndTime
        {
            get { return this._endTime; }
            set { this._endTime = value; }
        }
        
        private Guid _nodeId;
        
        /// <summary>
        /// Optional. Gets or sets the the node id.
        /// </summary>
        public Guid NodeId
        {
            get { return this._nodeId; }
            set { this._nodeId = value; }
        }
        
        private string _startTime;
        
        /// <summary>
        /// Optional. For the start time filter the value should be a datetime
        /// string in UTC format as defined in ISO 8601. For example,
        /// 2014-09-25T17:49:17.2252204Z
        /// </summary>
        public string StartTime
        {
            get { return this._startTime; }
            set { this._startTime = value; }
        }
        
        private string _type;
        
        /// <summary>
        /// Optional. Gets or sets the type of the node report.
        /// </summary>
        public string Type
        {
            get { return this._type; }
            set { this._type = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DscNodeReportListParameters class.
        /// </summary>
        public DscNodeReportListParameters()
        {
        }
    }
}
