// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// HDInsight activity properties.
    /// </summary>
    public abstract partial class HDInsightActivityPropertiesBase
    {
        private IList<string> _arguments;
        
        /// <summary>
        /// Optional. User specified arguments to HDInsightActivity.
        /// </summary>
        public IList<string> Arguments
        {
            get { return this._arguments; }
            set { this._arguments = value; }
        }
        
        private IList<string> _storageLinkedServices;
        
        /// <summary>
        /// Optional. Storage linked services.
        /// </summary>
        public IList<string> StorageLinkedServices
        {
            get { return this._storageLinkedServices; }
            set { this._storageLinkedServices = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the HDInsightActivityPropertiesBase
        /// class.
        /// </summary>
        public HDInsightActivityPropertiesBase()
        {
            this.Arguments = new LazyList<string>();
            this.StorageLinkedServices = new LazyList<string>();
        }
    }
}
