// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Represents the properties of an Azure SQL Database.
    /// </summary>
    public partial class ServerProperties
    {
        private string _administratorLogin;
        
        /// <summary>
        /// Optional. Gets administrator username for the server.
        /// </summary>
        public string AdministratorLogin
        {
            get { return this._administratorLogin; }
            set { this._administratorLogin = value; }
        }
        
        private string _administratorLoginPassword;
        
        /// <summary>
        /// Optional. Gets the administrator login password.
        /// </summary>
        public string AdministratorLoginPassword
        {
            get { return this._administratorLoginPassword; }
            set { this._administratorLoginPassword = value; }
        }
        
        private string _fullyQualifiedDomainName;
        
        /// <summary>
        /// Optional. Gets the fully qualified domain name of the server.
        /// </summary>
        public string FullyQualifiedDomainName
        {
            get { return this._fullyQualifiedDomainName; }
            set { this._fullyQualifiedDomainName = value; }
        }
        
        private string _version;
        
        /// <summary>
        /// Optional. Gets the version of the server.
        /// </summary>
        public string Version
        {
            get { return this._version; }
            set { this._version = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ServerProperties class.
        /// </summary>
        public ServerProperties()
        {
        }
    }
}
