// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.WindowsAzure.Management.Automation.Models;

namespace Microsoft.WindowsAzure.Management.Automation.Models
{
    /// <summary>
    /// The properties of the create connection type.
    /// </summary>
    public partial class ConnectionTypeCreateProperties
    {
        private IDictionary<string, FieldDefinition> _fieldDefinitions;
        
        /// <summary>
        /// Required. Gets or sets the field definitions of the connection type.
        /// </summary>
        public IDictionary<string, FieldDefinition> FieldDefinitions
        {
            get { return this._fieldDefinitions; }
            set { this._fieldDefinitions = value; }
        }
        
        private bool _isGlobal;
        
        /// <summary>
        /// Optional. Gets or sets a Boolean value to indicate if the
        /// connection type is global.
        /// </summary>
        public bool IsGlobal
        {
            get { return this._isGlobal; }
            set { this._isGlobal = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ConnectionTypeCreateProperties
        /// class.
        /// </summary>
        public ConnectionTypeCreateProperties()
        {
            this.FieldDefinitions = new LazyDictionary<string, FieldDefinition>();
        }
        
        /// <summary>
        /// Initializes a new instance of the ConnectionTypeCreateProperties
        /// class with required arguments.
        /// </summary>
        public ConnectionTypeCreateProperties(IDictionary<string, FieldDefinition> fieldDefinitions)
            : this()
        {
            if (fieldDefinitions == null)
            {
                throw new ArgumentNullException("fieldDefinitions");
            }
            this.FieldDefinitions = fieldDefinitions;
        }
    }
}
