// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.WindowsAzure.Management.Compute.Models;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// The List Available Extensions operation response.
    /// </summary>
    public partial class HostedServiceListAvailableExtensionsResponse : AzureOperationResponse, IEnumerable<ExtensionImage>
    {
        private IList<ExtensionImage> _extensionImages;
        
        /// <summary>
        /// Optional. The extensions that are available to add to your cloud
        /// service.
        /// </summary>
        public IList<ExtensionImage> ExtensionImages
        {
            get { return this._extensionImages; }
            set { this._extensionImages = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// HostedServiceListAvailableExtensionsResponse class.
        /// </summary>
        public HostedServiceListAvailableExtensionsResponse()
        {
            this.ExtensionImages = new LazyList<ExtensionImage>();
        }
        
        /// <summary>
        /// Gets the sequence of ExtensionImages.
        /// </summary>
        public IEnumerator<ExtensionImage> GetEnumerator()
        {
            return this.ExtensionImages.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of ExtensionImages.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
    }
}
