// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.WindowsAzure.Management.Compute.Models;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// The parameters Azure uses to create the vm image for the virtual
    /// machine.
    /// </summary>
    public partial class VMImageInput
    {
        private IList<DataDiskConfiguration> _dataDiskConfigurations;
        
        /// <summary>
        /// Optional. This corresponds to the DataDiskConfigurations of the VM
        /// Image used to create a new role. The DataDiskConfigurations
        /// element is only available using version 2014-10-01 or higher.
        /// </summary>
        public IList<DataDiskConfiguration> DataDiskConfigurations
        {
            get { return this._dataDiskConfigurations; }
            set { this._dataDiskConfigurations = value; }
        }
        
        private OSDiskConfiguration _oSDiskConfiguration;
        
        /// <summary>
        /// Optional. This corresponds to the OSDiskConfiguration of the VM
        /// Image used to create a new role. The OSDiskConfiguration element
        /// is only available using version 2014-10-01 or higher.
        /// </summary>
        public OSDiskConfiguration OSDiskConfiguration
        {
            get { return this._oSDiskConfiguration; }
            set { this._oSDiskConfiguration = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the VMImageInput class.
        /// </summary>
        public VMImageInput()
        {
            this.DataDiskConfigurations = new LazyList<DataDiskConfiguration>();
        }
    }
}
