// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Network.Models
{
    /// <summary>
    /// Parameters supplied to the Set Network Security Rule operation.
    /// </summary>
    public partial class NetworkSecuritySetRuleParameters
    {
        private string _action;
        
        /// <summary>
        /// Required. Gets or sets Action. Allow/Deny. Whether to allow or deny
        /// traffic.
        /// </summary>
        public string Action
        {
            get { return this._action; }
            set { this._action = value; }
        }
        
        private string _destinationAddressPrefix;
        
        /// <summary>
        /// Required. Gets or sets DestinationAddressPrefix. CIDR value of
        /// Destination IP from which traffic is coming. You can specify star
        /// (*) to map all traffic or one of pre-defined TAGs.
        /// </summary>
        public string DestinationAddressPrefix
        {
            get { return this._destinationAddressPrefix; }
            set { this._destinationAddressPrefix = value; }
        }
        
        private string _destinationPortRange;
        
        /// <summary>
        /// Required. Gets or sets destination Port (single port) or
        /// Destination Port Range (separated by “-“) or star (*) for all
        /// ports. All numbers are inclusive. Example: 80, 80-80, 80-81, *
        /// </summary>
        public string DestinationPortRange
        {
            get { return this._destinationPortRange; }
            set { this._destinationPortRange = value; }
        }
        
        private int _priority;
        
        /// <summary>
        /// Required. Gets or sets Priority. Value from 100 – 4096.
        /// </summary>
        public int Priority
        {
            get { return this._priority; }
            set { this._priority = value; }
        }
        
        private string _protocol;
        
        /// <summary>
        /// Required. Gets or sets Protocol. TCP, UDP, *.
        /// </summary>
        public string Protocol
        {
            get { return this._protocol; }
            set { this._protocol = value; }
        }
        
        private string _sourceAddressPrefix;
        
        /// <summary>
        /// Required. Gets or sets SourceAddressPrefix. CIDR value of Source IP
        /// from which traffic is coming. You can specify star (*) to map all
        /// traffic or one of pre-defined TAGs
        /// </summary>
        public string SourceAddressPrefix
        {
            get { return this._sourceAddressPrefix; }
            set { this._sourceAddressPrefix = value; }
        }
        
        private string _sourcePortRange;
        
        /// <summary>
        /// Required. Gets or sets Source Port (single port) or Source Port
        /// Range (separated by “-“) or star (*) for all ports. All numbers
        /// are inclusive. Example: 80, 80-80, 80-81, *
        /// </summary>
        public string SourcePortRange
        {
            get { return this._sourcePortRange; }
            set { this._sourcePortRange = value; }
        }
        
        private string _type;
        
        /// <summary>
        /// Required. Gets or sets type of Rule. Possible values: Inbound (to
        /// be evaluated against ingress traffic), Outbound (to be evaluated
        /// against egress traffic).
        /// </summary>
        public string Type
        {
            get { return this._type; }
            set { this._type = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the NetworkSecuritySetRuleParameters
        /// class.
        /// </summary>
        public NetworkSecuritySetRuleParameters()
        {
        }
    }
}
