// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.RemoteApp.Models
{
    /// <summary>
    /// The collection usage billiing summary.
    /// </summary>
    public partial class BillingUsageSummary
    {
        private double _includedUsage;
        
        /// <summary>
        /// Optional. The number of hours used which are included in the
        /// billing plan's base rate.
        /// </summary>
        public double IncludedUsage
        {
            get { return this._includedUsage; }
            set { this._includedUsage = value; }
        }
        
        private double _overageUsage;
        
        /// <summary>
        /// Optional. The number of hours used beyond the billing plan's
        /// included usage, but not exceeding the billing plan's maximum cost.
        /// </summary>
        public double OverageUsage
        {
            get { return this._overageUsage; }
            set { this._overageUsage = value; }
        }
        
        private double _totalUsage;
        
        /// <summary>
        /// Optional. The total usage hours by the user.
        /// </summary>
        public double TotalUsage
        {
            get { return this._totalUsage; }
            set { this._totalUsage = value; }
        }
        
        private string _userName;
        
        /// <summary>
        /// Optional. The user's UPN.
        /// </summary>
        public string UserName
        {
            get { return this._userName; }
            set { this._userName = value; }
        }
        
        private double _waivedUsage;
        
        /// <summary>
        /// Optional. The number of hours used beyond the billing plan's
        /// maximum cost.  These usage hours are not billed.
        /// </summary>
        public double WaivedUsage
        {
            get { return this._waivedUsage; }
            set { this._waivedUsage = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the BillingUsageSummary class.
        /// </summary>
        public BillingUsageSummary()
        {
        }
    }
}
