// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.WindowsAzure.Management.ServiceBus.Models;

namespace Microsoft.WindowsAzure.Management.ServiceBus.Models
{
    /// <summary>
    /// A response to a request for a list of topics.
    /// </summary>
    public partial class ServiceBusTopicsResponse : AzureOperationResponse, IEnumerable<ServiceBusTopic>
    {
        private IList<ServiceBusTopic> _topics;
        
        /// <summary>
        /// Optional. The list of topics.
        /// </summary>
        public IList<ServiceBusTopic> Topics
        {
            get { return this._topics; }
            set { this._topics = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ServiceBusTopicsResponse class.
        /// </summary>
        public ServiceBusTopicsResponse()
        {
            this.Topics = new LazyList<ServiceBusTopic>();
        }
        
        /// <summary>
        /// Gets the sequence of Topics.
        /// </summary>
        public IEnumerator<ServiceBusTopic> GetEnumerator()
        {
            return this.Topics.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of Topics.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
    }
}
