// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// Represents the object returned by DataContainerGroups Get call
    /// </summary>
    public partial class DataContainerGroupResponse
    {
        private IList<DataContainerGroup> _dCGroups;
        
        /// <summary>
        /// Required. List of DataContainerGroup objects
        /// </summary>
        public IList<DataContainerGroup> DCGroups
        {
            get { return this._dCGroups; }
            set { this._dCGroups = value; }
        }
        
        private string _followUpJobId;
        
        /// <summary>
        /// Required. The follow-up job identifier
        /// </summary>
        public string FollowUpJobId
        {
            get { return this._followUpJobId; }
            set { this._followUpJobId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DataContainerGroupResponse class.
        /// </summary>
        public DataContainerGroupResponse()
        {
            this.DCGroups = new List<DataContainerGroup>();
        }
        
        /// <summary>
        /// Initializes a new instance of the DataContainerGroupResponse class
        /// with required arguments.
        /// </summary>
        public DataContainerGroupResponse(IList<DataContainerGroup> dCGroups, string followUpJobId)
            : this()
        {
            if (dCGroups == null)
            {
                throw new ArgumentNullException("dCGroups");
            }
            if (followUpJobId == null)
            {
                throw new ArgumentNullException("followUpJobId");
            }
            this.DCGroups = dCGroups;
            this.FollowUpJobId = followUpJobId;
        }
    }
}
