// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// NicIPv6
    /// </summary>
    public partial class NicIPv6
    {
        private string _controller0IPv6Address;
        
        /// <summary>
        /// Optional. Gets or sets the Controller0IPv6Address
        /// </summary>
        public string Controller0IPv6Address
        {
            get { return this._controller0IPv6Address; }
            set { this._controller0IPv6Address = value; }
        }
        
        private string _controller1IPv6Address;
        
        /// <summary>
        /// Optional. Gets or sets the Controller1IPv6Address
        /// </summary>
        public string Controller1IPv6Address
        {
            get { return this._controller1IPv6Address; }
            set { this._controller1IPv6Address = value; }
        }
        
        private string _iPv6Address;
        
        /// <summary>
        /// Optional. Gets or sets the IPv6 Address
        /// </summary>
        public string IPv6Address
        {
            get { return this._iPv6Address; }
            set { this._iPv6Address = value; }
        }
        
        private string _iPv6Gateway;
        
        /// <summary>
        /// Optional. Gets or sets the IPv6 Gateway
        /// </summary>
        public string IPv6Gateway
        {
            get { return this._iPv6Gateway; }
            set { this._iPv6Gateway = value; }
        }
        
        private string _iPv6Prefix;
        
        /// <summary>
        /// Required. Gets or sets the IPv6 Prefix
        /// </summary>
        public string IPv6Prefix
        {
            get { return this._iPv6Prefix; }
            set { this._iPv6Prefix = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the NicIPv6 class.
        /// </summary>
        public NicIPv6()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the NicIPv6 class with required
        /// arguments.
        /// </summary>
        public NicIPv6(string iPv6Prefix)
            : this()
        {
            if (iPv6Prefix == null)
            {
                throw new ArgumentNullException("iPv6Prefix");
            }
            this.IPv6Prefix = iPv6Prefix;
        }
    }
}
