// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.WindowsAzure.Management.TrafficManager.Models;

namespace Microsoft.WindowsAzure.Management.TrafficManager.Models
{
    /// <summary>
    /// Describes the monitoring policy status
    /// </summary>
    public partial class DefinitionPolicyResponse : IEnumerable<DefinitionEndpointResponse>
    {
        private IList<DefinitionEndpointResponse> _endpoints;
        
        /// <summary>
        /// Optional. The list of Endpoints being monitored
        /// </summary>
        public IList<DefinitionEndpointResponse> Endpoints
        {
            get { return this._endpoints; }
            set { this._endpoints = value; }
        }
        
        private LoadBalancingMethod _loadBalancingMethod;
        
        /// <summary>
        /// Optional. Specifies the load balancing method to use to distribute
        /// connections.
        /// </summary>
        public LoadBalancingMethod LoadBalancingMethod
        {
            get { return this._loadBalancingMethod; }
            set { this._loadBalancingMethod = value; }
        }
        
        private DefinitionPolicyMonitorStatus _monitorStatus;
        
        /// <summary>
        /// Optional. Indicates health status for the overall load balancing
        /// policy.
        /// </summary>
        public DefinitionPolicyMonitorStatus MonitorStatus
        {
            get { return this._monitorStatus; }
            set { this._monitorStatus = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DefinitionPolicyResponse class.
        /// </summary>
        public DefinitionPolicyResponse()
        {
            this.Endpoints = new LazyList<DefinitionEndpointResponse>();
        }
        
        /// <summary>
        /// Gets the sequence of Endpoints.
        /// </summary>
        public IEnumerator<DefinitionEndpointResponse> GetEnumerator()
        {
            return this.Endpoints.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of Endpoints.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
    }
}
